!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! DIFF second edition 
! It's completely functional programm:
!  there are only two variables - global variables with rule lists
! Please, use this program only to figure out that Lisp is cool
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! This is the only one variables definition here.
! note: it's just global constants....
(seta
 (BINrules (
  ( +  ( dX + dY ) )
  ( *  ( ( dX * Y) + ( dY * X ) ) )
  ( /  ( ( dX / Y) - ( dY * ( X / (Y * Y) ) ) ) )
! ... (more to go)
 ))
 (UNrules (
  ( -    (- dX ) )
  ( sin  (cos X) )
  ( cos  (- (sin X) ) )
  ( ln   (1 / X) )
  ( exp  (dX * (exp X) ))
! ... (there are much more functions ...)
 ))
)

! The main function which does differential operation
(defun diff (l)
 (if (3-list l)
   (diff3 l)
   (if (2-list l)
     (diff2 l)
     (if (atom l)
       (if (= l 'x) 1 l)
       (print '"Suxx!!!")
     )
   )
 )
)

! just checks for list lengths
(defun 3-list (l) (= (lengthl l) 3))
(defun 2-list (l) (= (lengthl l) 2))

! [f(x)]'
(defun diff2 (l)
 (list (diff (nth 1 l)) '* (use-un-rule (find-un-rule (car l)) (nth 1 l)))
)

! [x /.../ y]', e.g. [x + y]', [x / y]'
(defun diff3 (l)
 (use-bin-rule (find-bin-rule (nth 1 l)) (car l) (nth 2 l))
)

! apply unary rule to the list
(defun use-un-rule (r l)
 (ins-x (car (cdr r)) l)
)

! Check is there variable in a list
(defun const-check (l)
 (if (null l) 'NIL
   (if (atom l) 
    (if (= l 'x) 'T
                 'NIL)
    (or (const-check (car l)) (const-check (cdr l)))
   )
 )
)

! to diff or not to diff....
(defun const-check1 (l)
 (if (const-check l) l 0)
)

! apply binary rule to the list
(defun use-bin-rule (r l1 l2)
 (ins-xy (car (cdr r)) l1 l2)
)

! Find all stubs in the unary rule and use them
(defun ins-x (l t)
 (if (null l) '()
  (if (atom l) 
    (if (= l 'X)
     t
     (if (= l 'dX)
      (diff (const-check1 t))
      l
     )
    )
    (append1 (list (ins-x (car l) t)) (ins-x (cdr l) t))
  )
 )
)

! Find all stubs in the binary rule and use'em
(defun ins-xy (l x y)
 (if (null l) '()
  (if (atom l) 
    (if (= l 'X)
     x
     (if (= l 'Y)
      y
      (if (= l 'dX) 
       (diff (const-check1 x))
       (if (= l 'dY)
        (diff (const-check1 y))
        l
       )
      )
     )
    )
    (append1 (list (ins-xy (car l) x y)) (ins-xy (cdr l) x y))
  )
 )
)



! Look for unary rule named "x"
(defun find-un-rule (x)
 (find-un-rule-0 UNrules x)
)

! Look for binary rule named "x"
(defun find-bin-rule (x)
 (find-bin-rule-0 BINrules x)
)

! Recursive search in the rule-list
(defun find-un-rule-0 (rlist x)
 (if (null rlist) (print '"Suxx!!!!")
  (if (= (car (car rlist)) x) 
     (car rlist)
     (find-un-rule-0 (cdr rlist) x)
  )
 )
)

! Just the same
(defun find-bin-rule-0 (rlist x)
 (if (null rlist) (print '"Suxx!!!!")
  (if (= (car (car rlist)) x) 
     (car rlist)
     (find-bin-rule-0 (cdr rlist) x)
  )
 )
)

!
! here the diff itself ends.
!
! Now we'll try to simplify the result
!

(defun simp (l)
 (if (atom l) l
  (if (2-list l) l
   (simp3 (simp (car l)) (nth 1 l) (simp (nth 2 l)))
  )
 )
)

(defun simp3 (a op b)
 (if (= op '+)
  ! A + B rules
  (if (and (numberp a) (numberp b)) 
   (+ a b)
   (if (numberp a)
    (simp3-na a op b)
    (if (numberp b)
     (simp3-na b op a)
     (list a op b)
    )
   )
  )
  (if (= op '*)
  ! A * B rules
   (if (and (numberp a) (numberp b))
    (* a b)
    (if (numberp a)
     (simp3-na a op b)
     (if (numberp b)
      (simp3-na b op a)
      (list a op b)
     )
    )
   )
   (list a op b)
  )
 )
)


(defun simp3-na (a op b)
  (if (= a 0)
   (if (= op '+) b
    (if (= op '*) 0
     (list a op b)
    )
   )
   (if (= a 1)
    (if (= op '*)
     b
     (list a op b)
    )
    (list a op b)
   )
  )
)

(defun d (&l)
 (simp (diff l) )
)

!
! Other simplifyer
!


(setq SIMPrules '(
 ( ( A op B) (exec (list op A B))) )
 ( ( X + X ) (list (2 * X) ) )
 ( ( 0 + Z ) Z )
 ( ( 1 * Z ) Z )
 ( ( 0 * Z ) 0 )
))


!
! Timings
!

(setq a 8)
(clockset)
(while (> a 0) (prog
 (simp (diff (copy '(sin (x + (2 * (cos (x / (5 * x) ) ) ) ) ) ) ) )
! (simp (diff '(sin (x + (2 * (cos (x / (5 * x) ) ) ) ) ) ) ) 
 (setq a (- a 1) )
))
(clockshow)


(setq a 8)
(clockset)
(while (> a 0) (prog
!(simp (diff (copy '(sin (x + (2 * (cos (x / (5 * x) ) ) ) ) ) ) ) )
 (simp (diff '(sin (x + (2 * (cos (x / (5 * x) ) ) ) ) ) ) ) 
 (setq a (- a 1) )
))
(clockshow)

!(/ 10 '()) ! dump the core

